type nat =
  | Z
  | S of nat

type 'a list =
  | Nil
  | Cons of 'a * 'a list

type relation 'a natlist : nat => 'a list with
  | Z => Nil
  | S xs => Cons (_, xs) when xs:'a natlist

let rec length l = match l with
  | Nil -> Z
  | Cons(_, x) -> S (length x)

let list_1_n = lifting length : (_ rev_natlist -> _ natlist)
