#(mode autolift)
#(mode unfold)

type 'a list = | Nil | Cons of ('a * 'a list)

let rec map f x = match x with
	| Nil -> Nil
    | Cons(x,xs) -> Cons(f x, map f xs)

type unit = U

type 'a vec3 = Vec3 of 'a * ('a * ('a * unit))

type ornament 'a list3 : 'a list => 'a vec3 with
 | Nil => ~
 | Cons(x, xs) => Vec3(x,xs) when xs : 'a list2
and 'a list2 : 'a list => 'a * ('a * unit) with
 | Nil => ~
 | Cons(x,xs) => (x,xs) when xs : 'a list1
and 'a list1 : 'a list => 'a * unit with
  | Nil => ~
  | Cons(x,xs) => (x,xs) when xs : 'a list0
and 'a list0 : 'a list => unit with
  | Nil => U
  | Cons(x,xs) => ~ when xs : 'a list0

let map_tuple = lifting map : ('a -> 'b) -> 'a list3 -> 'b list3
