
# 24 "disorn_aexpr.tex"
type expr' =
  | Const' of int
  | Add' of expr' * expr'
  | Mul' of expr' * expr'

# 32 "disorn_aexpr.tex"
type ornament aexpr : expr => expr' with
  | Const ( i ) => Const' ( i )
  | Add ( u , v ) => Add' ( u , v ) when u v : aexpr
  | ~ => Mul' ( u , v ) when u v : aexpr

# 41 "disorn_aexpr.tex"
let _eval' = lifting eval  : aexpr -> _

# 54 "disorn_aexpr.tex"
let eval' = lifting eval  : aexpr -> _
   with patch match __ with Mul' (u, v) -> #[mul (eval' u) (eval' v)]
