
# 14 "exprbis.tex"
type 'a option =
  | Some of 'a
  | None

type 'a list =
  | Nil
  | Cons of 'a * 'a list

# 24 "exprbis.tex"
let rec find x l = match l with
  | Cons ((k,v), t) ->
      begin match equal k x with True -> Some v | _ -> find x t end
  | Nil -> None

let rec remove x l = match l with
  | Cons (h, t) ->
      let t' = remove x t in
      begin match equal x h with  True -> t' | False -> Cons (h, t') end
  | Nil -> Nil

let rec append l1 l2 = match l1 with
  | Cons (h, t) -> Cons (h, append t l2)
  | Nil -> l2

# 72 "exprbis.tex"
val str__Unbound_variable : string
val str__Not_a_function : string
