
# 24 "desorn_aexpr.tex"
type expr' =
  | Const' of int
  | Add' of expr' * expr'
  | Mul' of expr' * expr'

# 32 "desorn_aexpr.tex"
type ornament aexpr : expr => expr' with
  | Const ( i ) => Const' ( i )
  | Add ( u , v ) => Add' ( u , v ) when u v : aexpr
  | ~ => Mul' ( u , v ) when u v : aexpr

# 41 "desorn_aexpr.tex"
let _eval' = lifting eval  : aexpr -> _

# 54 "desorn_aexpr.tex"
let eval' = lifting eval  : aexpr -> _
   with (match _e with Mul' (u, v) -> #a) => #a <- mul (eval' u) (eval' v) 
