
type 'a list =
  | Nil
  | Cons of 'a * 'a list

type u = U
type 'a alist =
  | ANil of u
  | ACons of ('a * ('a alist * u))

type ornament 'a alist_list : 'a alist => 'a list with
| ANil U => Nil
| ACons(x,xs) => Cons(x,xs) when xs : 'a alistu_list
and 'a alistu_list : ('a alist * u) => 'a list with
| (xs, U) => xs when xs : 'a alist_list

type ornament 'a gval_list : 'a gval => 'a alist with
| GData s => s when s : 'a gsum1_list
| GParam x => ~
and 'a gval_val : 'a gval => 'a with
| GData s => ~ when s : 'a gsum1_list
| GParam x => x
and 'a gsum1_list : 'a gsum => 'a alist with
| GSumZ p => ANil p when p : 'a gprodNil0_list
| GSumS s => ACons s when s : 'a gsum0_list
and 'a gsum0_list : 'a gsum => ('a * ('a alist * u)) with
| GSumZ p => p when p : 'a gprodCons2_list
| GSumS s => ~ when s : 'a gsum0_list
and 'a gprodNil0_list : 'a gprod => u with
| GNil => U
| GCons(v,vs) => ~ when v : 'a gval_list, vs : 'a gprodNil0_list
and 'a gprodCons0_list : 'a gprod => u with
| GNil => U
| GCons(v,vs) => ~ when v : 'a gval_list, vs : 'a gprodCons0_list
and 'a gprodCons1_list : 'a gprod => ('a alist * u) with
| GNil => ~
| GCons(v,vs) => (v,vs) when v : 'a gval_list, vs : 'a gprodCons0_list
and 'a gprodCons2_list : 'a gprod => 'a * ('a alist * u) with
| GNil => ~
| GCons(v,vs) => (v,vs) when v : 'a gval_val, vs : 'a gprodCons1_list

let map_alist = lifting gmap_unfolded : ('a -> 'b) -> 'a gval_list -> 'b gval_list
let map_list = lifting map_alist : ('a -> 'b) -> 'a alist_list -> 'b alist_list
