
type 'a list =
  | Nil
  | Cons of 'a * 'a list

type ornament 'a natlist : nat => 'a list with
  | Z => Nil
  | S n => Cons (_,n)  when n : 'a natlist

let _append = lifting add : _ natlist -> _ natlist -> _ natlist

let append = lifting add : _ natlist -> _ natlist -> _ natlist with
  patch #3[match m with Cons (a, _) -> a]

let map_list = lifting map_nat :  ('a -> 'b) -> 'a natlist -> 'b natlist
               with  patch #3[match n with Cons (x, n') -> f x]

let fold_list = lifting fold_nat :  _  -> _ -> 'a natlist -> 'b
