
type 'a list =
  | Nil
  | Cons of 'a * 'a list

type ornament 'a natlist : nat => 'a list with
  | Z => Nil
  | S(xs) => Cons(_,xs) when xs : 'a natlist

let _append = lifting add : 'a natlist -> 'a natlist -> 'a natlist

let append = lifting add : 'a natlist -> 'a natlist -> 'a natlist with
  patch #3[match m with Cons(x,_) -> x]

let add = lifting add : nat -> nat -> nat

let _add = lifting add

let append2 = lifting add with
  ornament #2, #5 <- natlist
  patch #3[match m with Cons(x,_) -> x]

let _double = lifting double

let double_list = lifting double with
  lifting #3 <- append

let double = lifting double : nat -> nat

type bool =
  | False
  | True

type ornament natbool : nat => bool with
  | Z => (True | False)
  | S xs => ~

let _zero_bool = lifting zero : natbool

let true = lifting zero : natbool with
  patch #2[Left ()]

let _one_bool = lifting one : natbool with ornament * <- natbool

type nattwo =
  | Z01
  | S0 of nattwo
  | S1 of nattwo

type ornament list_nattwo : bool list => nattwo with
  | Nil => Z01
  | Cons(False, xs) => S0(xs) when xs : list_nattwo
  | Cons(True, xs) => S1(xs) when xs : list_nattwo

type ornament natdiv_even : nat => nat with
  | Z => Z
  | S xs => S xs when xs : natdiv_odd
and natdiv_odd : nat => nat with
  | Z => ~
  | S xs => xs when xs : natdiv_even

let one' = lifting two : natdiv_even

let add_twice = lifting add_unfolded : natdiv_even -> nat -> nat
