
# 14 "origami.tex"
type nat =
  | Z
  | S of nat

type 'a natlike =
  | Z_
  | S_ of 'a

# 23 "origami.tex"
let natlike n =
  match n with
  | Z -> Z_
  | S x -> S_ x

let rec fold_nat f n = match n with
    | Z -> f Z_
    | S(x) -> f (S_ (fold_nat f x))

let add n m = fold_nat (fun z -> match z with Z_ -> m | S_ y -> S y) n
