
# 36 "origami.tex"
type 'a list =
  | Nil
  | Cons of 'a * 'a list

type ('a,'b) listlike =
  | Nil_
  | Cons_ of 'a * 'b

# 45 "origami.tex"
type ornament 'a natlist : nat => 'a list with
  | Z => Nil
  | S n => Cons(_,n) when n : 'a natlist

type ornament ('a,'b) natlistlike : 'b natlike =>  ('a,'b) listlike with
  | Z_ => Nil_
  | S_ x => Cons_ (_,x) when x : 'b

# 58 "origami.tex"
let listlike = lifting natlike : _ natlist -> _ natlistlike with
                    patch #3[match n with Cons(x,_) -> x]

# 68 "origami.tex"
let fold_list = lifting fold_nat : (_ natlistlike -> _) -> _ natlist -> _
                with patch #3[match n with Cons(x,_) -> x]

# 80 "origami.tex"
let append = lifting add : _ natlist -> _ natlist -> _ natlist with
             patch #3[match z with Cons_ (x,_) -> x]
