
# 26 "patch_language.tex"
let eq a b = True
type 'a list = Nil | Cons of 'a * 'a list

let rec assoc n l = match l with
  | Nil -> None
  | Cons((a, b), q) ->
    match eq a n with
    | True -> Some b
    | False -> assoc n q

# 66 "patch_language.tex"
  type location = Location of string * int * int
  type ('a, 'err) result =
    | Ok of 'a
    | Error of 'err

# 420 "patch_language.tex"
type expr_big' =
  | Absb' of ((expr_big' * location) -> (expr_big' * location))
  | Appb' of (expr_big' * location) * (expr_big' * location)
  | Constb' of int
  | Varb' of string
  | Letb' of string * (expr_big' * location) * (expr_big' * location)
  | Addb' of (expr_big' * location) * (expr_big' * location)
