
# 62 "tutorial.tex"
type nat =
  | Z
  | S of nat

let zero = Z
let one = S (Z)
let two = S (S Z)
let three = S (S (S Z))

let rec add m n =
  match m with
  | Z -> n
  | S m' -> S (add m' n)

let double n = add n n

# 328 "tutorial.tex"
let rec add_unfolded m n =
  match m with
  | Z -> n
  | S m' ->
     begin match m' with
     | Z -> S n
     | S m'' -> S (S (add_unfolded m'' n))
     end
