
# 88 "tutorial.tex"
type 'a list =
  | Nil
  | Cons of 'a * 'a list

# 99 "tutorial.tex"
type ornament 'a natlist : nat => 'a list with
  | Z => Nil
  | S(xs) => Cons(_,xs) when xs : 'a natlist

# 112 "tutorial.tex"
let _append = lifting add : 'a natlist -> 'a natlist -> 'a natlist

# 132 "tutorial.tex"
let append = lifting add : 'a natlist -> 'a natlist -> 'a natlist with
  patch #3[match m with Cons(x,_) -> x]

# 148 "tutorial.tex"
let add = lifting add : nat -> nat -> nat

# 163 "tutorial.tex"
let _add = lifting add

# 180 "tutorial.tex"
let append2 = lifting add with
  ornament #2, #5 <- natlist
  patch #3[match m with Cons(x,_) -> x]

# 194 "tutorial.tex"
let _double = lifting double

# 204 "tutorial.tex"
let double_list = lifting double with
  lifting #3 <- append

# 212 "tutorial.tex"
let double = lifting double : nat -> nat

# 244 "tutorial.tex"
type bool =
  | False
  | True

# 249 "tutorial.tex"
type ornament natbool : nat => bool with
  | Z => (True | False)
  | S xs => ~

# 256 "tutorial.tex"
let _zero_bool = lifting zero : natbool

# 267 "tutorial.tex"
let true = lifting zero : natbool with
  patch #2[Left ()]

# 276 "tutorial.tex"
let _one_bool = lifting one : natbool with ornament * <- natbool

# 287 "tutorial.tex"
type nattwo =
  | Z01
  | S0 of nattwo
  | S1 of nattwo

# 293 "tutorial.tex"
type ornament list_nattwo : bool list => nattwo with
  | Nil => Z01
  | Cons(False, xs) => S0(xs) when xs : list_nattwo
  | Cons(True, xs) => S1(xs) when xs : list_nattwo

# 305 "tutorial.tex"
type ornament natdiv_even : nat => nat with
  | Z => Z
  | S xs => S xs when xs : natdiv_odd
and natdiv_odd : nat => nat with
  | Z => ~
  | S xs => xs when xs : natdiv_even

let one' = lifting two : natdiv_even

# 338 "tutorial.tex"
let add_twice = lifting add_unfolded : natdiv_even -> nat -> nat
