type 'a list =
  | Nil
  | Cons of ('a * 'a list)

type unit = U

type 'a vec3 = Vec3 of 'a * ('a * ('a * unit))

let rec map_tuple f x = match x with
    | Vec3(x, xs) -> Vec3(f x, map_auto1 f xs)
 and map_auto1 f x = match x with
    | (x, xs) -> (f x, map_auto2 f xs)
 and map_auto2 f x = match x with
    | (x, xs) -> (f x, map_auto3 f xs)
 and map_auto3 f x = U
