type bool  = True  | False
type bool' = True' | False'
type expr  = Expr0 | Expr of bool
type expr' = Expr' of bool * bool'

type ornament boolprimisant: bool => bool' with
| True  => True'
| False => False'

(*type ornament o: expr => expr' with
| Expr0  => Expr' (False, _)
| Expr a => Expr' (True,  a) when a: boolprimisant*)

type dual = Cons1_false of bool' | Cons2_true of bool'
type expr2 = Expr'_1 of bool * bool' | Expr'_2 of bool * bool'

type ornament o': expr => expr2 with
| Expr0 => Expr'_1 (False, _)
| Expr a => Expr'_2 (True, a) when a:boolprimisant
| ~ => _

type ornament o'': expr2 => expr' with
| Expr'_1 (False, a) => Expr'(False, a)
| Expr'_2 (True, a) => Expr'(True, a)
| _ => ~

let switch x = match x with
| Expr0 -> Expr True
| Expr True -> Expr0
| Expr False -> Expr False

let s = lifting switch: o' -> o'


let r = lifting s: o'' -> o''

type expr3 = Expr''_1 of bool * bool
              | Expr''_2 of bool * bool'

type ornament o3: expr2 => expr3 with
| Expr'_1(a, b) =>  Expr''_1(a, b) when b:rev_boolprimisant
| Expr'_2(a, b) => Expr''_2(a, b)

let c x = match x with
| (Expr'_1(_, a) | Expr'_2(_, a)) -> match a with
| True' -> False'
| False' -> True'

let d = lifting c: o3 -> bool'
