type 'a list =
  | Nil
  | Cons of 'a * 'a list

type 'a list' =
    | Nil'
    | Cons' of 'a list' * 'a

type nat = Z

let rec concat m n =
  match m with
  | Nil' -> n
  | Cons' (q, a) -> Cons' (concat q n, a)

type ornament ('c, 'b) listlist : 'c list' => 'b list with
  | Nil' => Nil
  | Cons'(xs, _) => Cons(_, xs) when xs : ('c, 'b) listlist


let add_gen = lifting concat: ('a, 'b) listlist -> ('a, 'b) listlist -> ('a, 'b) listlist

let add = lifting concat: ('a, 'b) listlist -> ('a, 'b) listlist -> ('a, 'b) listlist
with #2 <- match m with | Cons(a, _) -> a
