type binop' =
  | Add'
  | Mul'

type expr' =
  | Const' of int
  | Binop' of binop' * expr' * expr'

type ornament oexpr : expr => expr' with
  | Const ( i ) => Const' ( i )
  | Add ( u , v ) => Binop' ( Add' , u , v ) when u v : oexpr
  | Mul ( u , v ) => Binop' ( Mul' , u , v ) when u v : oexpr

let eval = lifting eval : oexpr -> int

#(mode input)
let  expr2expr' = lifting copy : expr -> oexpr
