type expr =
  | Const of int
  | Add of expr * expr

type expr' =
  | Const' of int
  | Add' of expr' * expr'
  | Mul' of expr' * expr'

         
type ornament aexpr : expr => expr' with
  | Const ( i ) => Const' ( i )
  | Binop' ( Add' , u , v ) => Add ( u , v ) when u v : ioexpr
  | Binop' ( Mul' , u , v ) => Mul ( u , v ) when u v : ioexpr

let eval' = lifting eval  : ioexpr -> _


