
type 'a list = Nil | Cons of 'a * 'a list

type ornament 'a list0 : 'a list => unit with
  | Nil => ()
  | Cons(a,b) => ~
    
type ornament 'a list1 : 'a list => 'a * unit with
  | Nil => ~
  | Cons(y,z) => (y,z) when z : 'a list0

type ornament 'a list2 : 'a list => ('a * ('a * unit)) with
  | Nil => ~
  | Cons(x,ys) => (x,ys) when ys : 'a list1

let rec map f x =
  match x with
  | Nil -> Nil
  | Cons(x, xs) -> Cons(f x, map f xs)

let map0 f x =
  match x with
  | Nil -> Nil
  | Cons(x, xs) -> Cons(f x, map f xs)

let map1 f x =
  match x with
  | Nil -> Nil
  | Cons(x, xs) -> Cons(f x, map0 f xs)

let map2 f x =
  match x with
  | Nil -> Nil
  | Cons(x, xs) -> Cons(f x, map1 f xs)

let map0t = lifting map0 : ('a -> 'b) -> 'a list0 -> 'b list0

let map1t = lifting map1 : ('a -> 'b) -> 'a list1 -> 'b list1

let map2t = lifting map2 : ('a -> 'b) -> 'a list2 -> 'b list2


type 'a option = None | Some of 'a
val fail : 'a 

let hd x =
  match x with
    Nil -> fail
  | Cons (h, t) -> h

type ornament 'a hd : 'a list => 'a * 'a list with
  | Nil => ~
  | Cons (h, t) => (h, t) 
  
let hd' = lifting hd : 'a hd -> 'a
