#(mode autolift)
#(mode unfold)
#(mode nogenpatches)

type 'a list = | Nil | Cons of ('a * 'a list)

let rec map f x = match x with
  | Nil -> Nil
  | Cons(x,xs) -> Cons(f x, map f xs)

type 'a vec = Vec of 'a * 'a

type relation 'b list3deep : 'b list => 'b vec with
  | Cons(x, Cons(y, _)) => Vec(x, y)
  | _ => ~

let map_tuple = lifting map: ('a -> 'b) -> 'a list3deep -> 'b list3deep
