
# 33 "disorn_expr_loc.tex"
type expr =
  | Abs of (expr -> expr)
  | App of expr * expr
  | Const of int

type ornament add_loc : expr => expr_loc with
  | Abs f => Abs' (f, _) when f : add_loc -> add_loc
  | App (u, v) => App' (u, v, _) when u v : add_loc
  | Const i => Const' (i, _)

type ornament ('a, 'err) optres : 'a option => ('a, 'err) result with
  | Some a => Ok a
  | None => Error _


let eval = lifting eval_loc : rev_add_loc -> (rev_add_loc, location) rev_optres

# 87 "disorn_expr_loc.tex"
type ornament add_loc2 : expr => expr' * location with
  | Abs f => (Abs'' f, _) when f : add_loc2 -> add_loc2
  | App (u, v) => (App'' (u, v), _) when u v : add_loc2
  | Const (i) => (Const'' (i), _)

let eval = lifting eval_loc2 : rev_add_loc2 -> (rev_add_loc2, location) rev_optres
