
# 12 "expr_smaller.tex"
type id = Identifier
type 'a list = Nil | Cons of 'a * 'a list
type 'a option = None | Some of 'a
type bool = True | False
val equal : 'a -> 'a -> bool
val fail : 'a -> 'b
let assoc x l = match l with
  | Nil -> None
  | Cons ((y, v), l) -> (match equal x y with True -> Some v | False -> None)
(* val assoc : 'a -> ('a * 'b) list -> 'b option *)
let bind x f = match x with Some v -> f v | None -> None
(* val bind : 'a option -> ('a -> 'b option) -> 'b option *)
