
type nat = | Z
           | S of nat

type 'a list =
  | Nil
  | Cons of 'a * 'a list

let rec map_list f n = match n with
  | Nil -> Nil
  | Cons(x, n') -> Cons(f x, map_list f n')

let rec map_list2 f n = match n with
  | Nil -> Nil
  | Cons(x, n') ->
    let g = f x in
    Cons(f x, map_list2 f n')


  type t = Empty | Node of t * elt * t * int

  let create l vb r =
    match vb with
    | Box v ->
    let hl = match l with Empty -> i0 | Node(_,_,_,h) -> h in
    let hr = match r with Empty -> i0 | Node(_,_,_,h) -> h in
    Node(l, v, r, (match gte hl hr with True -> plus hl i1 | False -> plus hr i1))
