
# 158 "desorn_set.tex"
type t = Empty | Node of t * elt * t * int

# 162 "desorn_set.tex"
type ornament 'a setmap : t => 'a map with
     | Empty => MEmpty
     | Node(l,v,r,n) => MNode(l,v,_,r,n) when l r : 'a setmap

type ornament ('a,'new) box2 : 'a box => ('a * 'new) box with
     | Box a => Box (a,_)

type ornament ('a, 'b) option2 : 'a option => ('a * 'b) option with
     | None => None
     | Some u => Some (u, _)

let invalid_arg = lifting minvalid_arg : _ rev_setmap

let height = lifting mheight : _ rev_setmap -> _

let create = lifting mcreate : _ rev_setmap -> _ rev_box2 -> _ rev_setmap -> _ rev_setmap


let bal = lifting mbal : _ rev_setmap -> _ rev_box2 -> _ rev_setmap -> _ rev_setmap

let add = lifting madd : _ rev_box2 -> _ rev_setmap -> _ rev_setmap

let singleton = lifting msingleton : _ rev_box2 -> _ rev_setmap

let min_binding = lifting mmin_binding : _ rev_setmap -> _ rev_option2

let max_binding = lifting mmax_binding : _ rev_setmap -> _ rev_option2
