
type set =
  | Empty
  | Node of set * elt * set * int

type ornament mapset : unit map => set with 
| MNode (l,k,(),r,i) =>  Node (l,k,r,i) when l r : mapset
| MEmpty => Empty

type ornament 'a debox2 : ('a * unit) box => 'a box  with 
      | Box (a,()) => Box a

type ornament 'a deoption2 : ('a * unit) option => 'a option with
      | None => None
      | Some (u, ()) => Some u

let invalid_arg = lifting minvalid_arg : mapset

let height = lifting mheight : mapset -> _

let create = lifting mcreate : mapset -> _ debox2 -> mapset -> mapset 

let bal = lifting mbal : mapset -> _ debox2 -> mapset -> mapset

let add = lifting madd : _ debox2 -> mapset -> mapset 

let singleton = lifting msingleton : _ debox2 -> mapset 

let min_elt = lifting mmin_binding : mapset -> _ deoption2 

let max_elt = lifting  mmax_binding : mapset -> _ deoption2
