
type nat =
  | Z
  | S of nat

let rec add m n = match m with
  | Z -> n
  | S m' -> S (add m' n)

let rec map_nat f n = match n with
  | Z -> Z
  | S n' -> S (map_nat f n')

let rec fold_nat s z n = match n with
  | Z -> z
  | S n' -> s (fold_nat s z n')
