
# 79 "redblack.tex"
type tree =
  | SEmpty
  | SNode of tree * elt * tree

# 86 "redblack.tex"
type relation simplification: redblack => tree with
  | Empty => SEmpty
  | (Red(a, e, b) | Black(a, e, b)) => SNode(a, e, b) when a b: simplification

# 94 "redblack.tex"
let simpl_mem = lifting mem: elt -> simplification -> bool

let simpl_singleton = lifting singleton: elt -> simplification

let simpl_add = lifting add: elt -> simplification -> simplification

# 174 "redblack.tex"
let simpl_add = lifting add: elt -> simplification -> simplification with
  | (match #a with Left _ -> _a) => #a <- Left ()
