type bool = True | False
let f x y =
  let g = fun r -> r in
  let k = g x in
  match y with
  | True -> x
  | False -> x

let c = lifting f

type elt = Element
type simplt = SEmpty | SNode of simplt * elt * simplt
type 'a box = Box of 'a
type int = Integer
val i0: int
val i1 : int
val gte: int -> int -> bool
val plus: int -> int -> int

let mcreate l vb r = match vb with
    | Box v ->
      let hl = match l with
          | SEmpty -> i0
          | SNode(_, _, _) -> i0
      in
      let hr = match r with
          | SEmpty -> i0
          | SNode(_, _, _) -> i0
      in
      let x = match gte hl hr with
          | True -> plus hl i1
          | False -> plus hr i1
      in
      SNode(l, v, r)

let create = lifting mcreate: simplt -> elt box -> simplt -> simplt
